
function [Xtp,Ytp,Yte,Pp,k,P,XtpAdj,VarYtp, EXtpAdj, EYtp,RstockEstimatedAdj,RstockEstimatedPre,rEeAdj,rEePre]=kalman_filt(Rstock,Rmarket,param_set)
alpha=param_set(1);
r=sqrt(param_set(2));
q=sqrt(param_set(3));
a=param_set(4);
mu0=param_set(5);
sigma0=sqrt(param_set(6));
x0=mu0+sqrt(sigma0)*randn;
Yt=Rstock; %given
mt=Rmarket;


% a=1;
N=length(Rstock);
rnd=randn(N,2);

XtpAdj(1)=x0;
Xtp(1) = a*XtpAdj(1)+ q*rnd(1,2);

Pp(1) =(a*sigma0)^2+q^2; 
k(1)=Pp(1)*mt(1)/(Pp(1)*mt(1)^2+r^2);
P(1)=(1-k(1)*mt(1))^2*Pp(1);

for i=1:N-1
%     a=i+1/100;
    Xtp(i+1) = a*XtpAdj(i)+ q*rnd(i+1,2);
    Ytp(i+1) = mt(i)*Xtp(i+1)+alpha+r*rnd(i+1,1);
    Yte(i+1) = Yt(i+1)-Ytp(i+1);
    Pp(i+1)  = a^2*(P(i)+k(i)^2*r^2)+q^2;
    %Pp(i+1)  = a^2*(P(i))+q^2;
    k(i+1)=Pp(i+1)*mt(i+1)/(Pp(i+1)*mt(i+1)^2+r^2);
    
    P(i+1)=(1-k(i+1)*mt(i+1))^2*Pp(i+1);
    %P(i+1)=(1-k(i+1)*mt(i+1))*Pp(i+1);
    XtpAdj(i+1)=Xtp(i+1)+k(i+1)*Yte(i+1);
end
Xtp=Xtp';Ytp=Ytp';Yte=Yte';
Pp=Pp';k=k';P=P';XtpAdj=XtpAdj';

% a=1;
EXtpAdj(1)=(1-k(1)*mt(1))*a*mu0+k(1)*(Yt(1)-alpha);
for i=1:N
    VarXtpAdj(i)=Pp(i)*(1-mt(i)*k(i))^2+k(i)^2*r^2;
    VarYtp(i)=VarXtpAdj(i)*mt(i)^2+r^2;
%     a=i;
    if i>1
        EXtpAdj(i)=(1-k(i)*mt(i))*a*EXtpAdj(i-1)+k(i)*(Yt(i)-alpha);
    end
end
EXtpAdj=EXtpAdj';
EYtp=mt.*EXtpAdj;
VarYtp=VarYtp';

RstockEstimatedAdj=alpha+Rmarket.*XtpAdj+r*rnd(:,1);
rEeAdj=RstockEstimatedAdj-Rstock;
RstockEstimatedPre=alpha+Rmarket.*Xtp+r*rnd(:,1);
rEePre=RstockEstimatedPre-Rstock;